; ti92plus	SET	1	; Juste changer le ; pour bien compiler...
ti92		SET	1
; ti89		SET	1

;-------------------------------------------------------------
; Dsol, je vire l'en-tte mythique de
; cet incroyable jeu ;) Si je le "finis" c'est
; d'ailleurs pour viter que l'on en reparle
; sur #ti principalement...
; Merci d'effacer votre ancien source par
; le nouveau...
;-------------------------------------------------------------
; Web : http://brian.t.free.fr
; Mail : brian.t@free.fr
; - SolarStriker Project -
;-------------------------------------------------------------

	IFD ti92
	include	"tios.h"
	xdef	_main
	xdef	_comment
	ENDIF

	IFND ti92
	include	"os.h"
	xdef	_nostub
	ENDIF

	IFD ti92plus
	xdef	_ti92plus
	ENDIF
	IFD ti89
	xdef	_ti89
	ENDIF

;-------------------------------------------------------------
; Table des quivalences
;-------------------------------------------------------------

	IFND ti89
Vert_ecran		EQU	128
Maximum_position	EQU	20
Position_VY		EQU	119
	ENDIF
	IFD ti89
Vert_ecran		EQU	100
Maximum_position	EQU	10
Position_VY		EQU	91
	ENDIF

Horz_ecran		EQU	30
Minimum_position	EQU	5
Activer_Masque	EQU	$700
Desactiver_Masque	EQU	0

;-------------------------------------------------------------
; Liste des macros
;-------------------------------------------------------------

Desactiver_interruptions	MACRO
	move.w	#Activer_Masque,d0
	trap		#1
	ENDM

Activer_interruptions		MACRO
	move.w	#Desactiver_Masque,d0
	trap		#1
	ENDM

	IFD ti92
eraseVScreen		MACRO
	move.w	num_handle,-(a7)
	jsr     		tios::HeapFree
	lea		2(a7),a7
	ENDM
	ENDIF

createVScreen		MACRO
	move.l		#Horz_ecran*8,-(a7)
	IFD ti92
	jsr		tios::HeapAllocThrow
	lea		4(a7),a7
	move.w	d0,num_handle
	tios::DEREF d0,a0
	ENDIF
	IFND ti92
	lea		4(a7),a7
	move.l		#$F0A8,a0		; Euh... ne faites surtout pas comme moi ;)
	ENDIF					; Je ne sais pas ce que je suis en train d'craser ! (Graph en thorie...)
	move.l		a0,add_vscreen	; Mais comme c'est diffrent sur chaques roms, c'est chaud sans le Heap...
	ENDM					; ...Je n'ai trouv aucune doc l-dessus, peut-tre sur ti.com ?

read_key			MACRO
	move.w	#$FFFE,$600018
	ENDM

	IFND ti89
test_right			MACRO
	btst.b		#6,$60001b
	beq		right_ok
	ENDM
test_left			MACRO
	btst.b		#4,$60001b
	beq		left_ok
	ENDM
test_shift			MACRO
	btst.b		#2,$60001b
	beq		shift_ok
	ENDM
	ENDIF

	IFD ti89
test_right			MACRO
	btst.b		#3,$60001b
	beq		right_ok
	ENDM
test_left			MACRO
	btst.b		#1,$60001b
	beq		left_ok
	ENDM
test_shift			MACRO
	btst.b		#5,$60001b
	beq		shift_ok
	ENDM
	ENDIF

;-------------------------------------------------------------
; Code principal du jeu
;-------------------------------------------------------------

_main:
	createVScreen
	Desactiver_interruptions
	move.b	#10,xsprite
	move.l		#80,xship
	move.b	#0,Inc_vscreen
	move.b	#1,start_game
start:
	read_key
	move.b	Inc_vscreen,d0
	tst.b		d0
	bne		Skip_pattern
	bsr		clearVScreen
	bsr		chooserand
	bsr		spriteleft
	bsr		spriteright
	bsr		verifcoord
Skip_pattern:
	move.b	start_game,d0
	tst.b		d0
	beq		continue_inc
	add		#1,d0
	move.b	d0,start_game
	cmp.b		#140,d0
	bne		continue_inc
	move.b	#0,start_game
continue_inc:
	bsr		copyscreen
	read_key
	move.l		xship,d0
	move.l		#Position_VY,d1
	bsr		put_sprite
	test_right
	test_left
	test_shift
	bra		start

right_ok:
	move.l		xship,d0
	add		#1,d0
	move.l		d0,xship
	bra		start
left_ok:
	move.l		xship,d0
	sub		#1,d0
	move.l		d0,xship
	bra		start
shift_ok:
	IFD ti92
	eraseVScreen
	ENDIF
	Activer_interruptions
quit:

	rts

;-------------------------------------------------------------
; Liste des sous-routines
;-------------------------------------------------------------

; *** Routine de l'article "Affichage de sprites 8*8" modifie *** (Hein Technic a marche !)

put_sprite:					; D0 = (X) et D1 = (Y) en entre
	lea		ship(PC),a0
	move.l		#LCD_MEM,a1	; Mmoire de la vido
	move.l		d1,d2			; d1 et d2 contiennent la mme valeur
	lsl.l		#5,d1			; On multiplie d1 par 2^5, soit 32
	lsl.l		#1,d2			; On multiplie d2 par 2^1, soit 2
	sub		d2,d1			; On soustrait d1*32 et d2*2, en factorisant on a d1*(32-2) d'ou d1*30 !
	move.l		d0,d2			; On copie d0 dans d2
	lsr		#3,d0			; On divise d0 par 2^3 soit 8
	and		#7,d2			; l'instruction AND permet grce  un miracle de la nature d'obtenir le reste de d2/8
	add		d0,d1			; Ajout du reste  d1
	add		d1,a1			; Ajout du total  a1
	move.b	#8,d3
	sub		d2,d3
	move.w	#7,d1
boucle:
	clr.w		d0
	move.b	(a0)+,d0
	lsl.w		d3,d0
	move.b	Horz_ecran+1(a1),d4
	eor.b		d4,Horz_ecran+1(a1)
	eor.b		d0,1(a1)
	move.b	1(a1),d4
	cmp.b		d0,d4
	bne		collision
	lsr.w		#8,d0
	move.b	Horz_ecran(a1),d4
	eor.b		d4,Horz_ecran(a1)
	eor.b		d0,(a1)
	move.b	(a1),d4
	cmp.b		d0,d4
	bne		collision
	add		#Horz_ecran,a1
	dbra		d1,boucle
	rts

Copie_rapide_regs:
	move.b	(a1),Horz_ecran*0(a0)
	move.b	1(a1),Horz_ecran*1(a0)
	move.b	2(a1),Horz_ecran*2(a0)
	move.b	3(a1),Horz_ecran*3(a0)
	move.b	4(a1),Horz_ecran*4(a0)
	move.b	5(a1),Horz_ecran*5(a0)
	move.b	6(a1),Horz_ecran*6(a0)
	move.b	7(a1),Horz_ecran*7(a0)
	rts

spriteleft:
	clr.w		d3
	move.b	xsprite,d3
	sub		#2,d3
	move.l		add_vscreen,a0
	lea		principal,a1
	move.b	xvar,d4
	tst.b		d4
	bne		\copyxl
	add		#1,d3
\copyxl
	bsr		Copie_rapide_regs
	add		#1,a0
	dbra.b		d3,\copyxl
	move.b	xvar,d4
	tst.b		d4
	beq		\gauchgh
	cmp.b		#2,d4
	beq		\gauchdr
	lea		gauchec,a1
	bsr		Copie_rapide_regs
	rts
\gauchgh
	lea		gauchem,a1
	bsr		Copie_rapide_regs
	rts
\gauchdr
	lea		gauchep,a1
	bsr		Copie_rapide_regs
	rts

spriteright:
	move.l		add_vscreen,a0
	lea		principal,a1
	clr.l		d3
	clr.l		d4
	move.b	xsprite,d3
	add		#7,d3
	add		d3,a0
	move		#Horz_ecran-1,d4
	sub		d3,d4
	move.b	xvar,d6
	cmp.b		#2,d6
	bne		\copyxr
	add		#1,d4
	sub		#1,a0
\copyxr
	bsr		Copie_rapide_regs
	add		#1,a0
	dbra.b		d4,\copyxr
	move.l		add_vscreen,a0
	clr.l		d3
	clr.l		d4
	move.b	xsprite,d3
	add.b		#6,d3	
	add		d3,a0
	move.b	xvar,d4
	cmp.b		#0,d4
	beq		\droitegh
	cmp.b		#2,d4
	beq		\droitedr
	lea		droitec,a1
	bsr		Copie_rapide_regs
	rts
\droitegh
	lea		droitep,a1
	bsr		Copie_rapide_regs
	rts
\droitedr
	lea		droitem,a1
	sub		#1,a0
	bsr		Copie_rapide_regs
	rts

copyscreen:
	move.l		#LCD_MEM,a1
	add		#Horz_ecran*Vert_ecran,a1
	move.l		a1,a0
	sub		#Horz_ecran,a0
	move.l		#Horz_ecran*(Vert_ecran-1)-1,d4
\zigo
	move.b	-(a0),-(a1)
	dbra		d4,\zigo

	move.l		#LCD_MEM,a1
	move.l		add_vscreen,a0
	clr.l		d5
	move.b	Inc_vscreen,d5
	add		d5,a0
	move.w	#Horz_ecran-1,d4
\boucle
	move.b	(a0)+,(a1)+
	dbra		d4,\boucle
	cmp.b		#210,d5
	bne		\addz		
	move.b	#0,Inc_vscreen
	rts
\addz
	add		#30,d5
	move.b	d5,Inc_vscreen
	rts

clearVScreen:
	move.w	#Horz_ecran*2-1,d4
	move.l		add_vscreen,a0
\loop
	clr.l		(a0)+
	dbra		d4,\loop
	rts

chooserand:
	move.b	#0,xvar
	move.l		#3,d0
	jsr		random
	move.b	d0,xvar
	tst.b		d0
	beq		\addgh
	cmp.b		#2,d0
	beq		\adddr
	rts
\addgh
	move.b	xsprite,d0
	sub.b		#1,d0
	move.b	d0,xsprite
	rts
\adddr
	move.b	xsprite,d0
	add.b		#1,d0
	move.b	d0,xsprite
	rts

verifcoord:
	cmp.b		#Minimum_position,xsprite
	beq		\remindr
	cmp.b		#Maximum_position,xsprite
	beq		\remingh
	rts
\remindr
	move.b	xsprite,d0
	add.b		#1,d0
	move.b	d0,xsprite
	rts
\remingh
	move.b	xsprite,d0
	sub.b		#1,d0
	move.b	d0,xsprite
	rts

random:					; Extrait de FLIB pour Fargo II ( David Ellsworth )
	move.l		d1,-(sp)
	move.w	rand_seed(pc),d1
	mulu.w		#31421,d1
	add.w		#6927,d1
	mulu.w		d1,d0
	move.w	d1,rand_seed
	clr.w		d0
	swap		d0
	move.l		(sp)+,d1
	rts

collision:
	move.b	start_game,d7
	tst.b		d7
	beq		vraie_collision
	rts
vraie_collision:
	lea		4(a7),a7
	IFD ti92
	eraseVScreen
	ENDIF
	Activer_interruptions
	bra		quit

;******************** Program Variables ***********************

; Variables : Les sprites du jeu...

	include		"Sprites.h"

; Variables du jeu :

xship		dc.l	0
xvar		dc.b	0
xsprite		dc.b	0
Inc_vscreen	dc.b	0
start_game	dc.b	0
rand_seed	dc.w	0
num_handle	dc.w	0
add_vscreen	dc.l	0

_comment	dc.b	"X-Rak 1.0",0

;********************** End of Program ************************
	end

; Je laisse les grandes citations ? Allez, pour la mmoire ;)

; - "Non, je ne suis pas anglophobes"
; - "(no, it is a joke)"
; - "Si bidulecalc veut bien le mettre, essayez ticarnet98"
; - "Pas besoin de faire un "beau" vaisseau, je le
; remplace par une lettre, comme Phoenix :-)"

; Et pour les remerciements, on va laisser les anciens quand mme...

; Dans mes sources, y'a plus de commentaires que d' ASM
; C'est pour cel que la doc est redirig vers la source
; Merci  :
;          	- Gravitics TEAM (Etan21, Crashman, Kawasaweb, et vous ?)
;	- Buggy (Reviens quand tu veux dans la Gravitics)
;	- Zorglop (Merci sincrement pour Zguide, sans lequel j'aurais...
;	...peut-tre abandonn l'assembleur)
;	- Doors Team (Xavier qui rpond  mes grandes interrogations mtaphysique)
;	- Nexo Software (Fargo Program Editor surtout)
;	Et  tous les autres !